use anyhow::{Context, Result};

pub async fn tap_junction_main(
    tx_for_mod: tokio::sync::mpsc::Sender<u8>,
    rx_for_eth_inb: tokio::sync::mpsc::Receiver<Vec<u8>>,
) -> Result<()> {
    const MTU: i32 = 1500;
    let tap_dev = tokio_tun::Tun::builder()
        //.tap()
        .name("sang")
        .mtu(MTU)
        .address("10.185.0.1".parse()?)
        .netmask("255.255.255.0".parse()?)
        .up()
        .try_build()
        .context("failed to construct tap device! could this be a permissions issue? try `setcap CAP_NET_ADMIN=ep /path/to/binary`")?;

    let mut buf = [0u8; MTU as usize];
    loop {
        let frame_length = tap_dev.recv(&mut buf).await?;
        println!("{:?}", &buf[..frame_length]);
        //tx_for_mod.send((&buf[..frame_length]).to_vec()).await?; // by frame
        for byte in buf[..frame_length].iter() {
            tx_for_mod.send(*byte).await
            .expect("tap_junction channel tx failed. probable panic at dest");
        }
    }
}
