pub struct WireDataBytes {
    data: Vec<u8>,
}

pub enum WireDataFrame {
    Hello {
        src: SangAddr,
        dest: SangAddr,
    },
    Complaint(Complaint),
    Data,
    ModeChange,
}

pub type SangAddr = [i64; 4];

pub enum Complaint {
    // you're peaking! please quiet down
    VolumeTooHigh,  

    // i can't / can barely make out what you're saying!
    VolumeTooLow,   

    // this band is lousy - maybe it's noisy or lossy, or
    //  suffers from pitch/phase shift or instability, or is
    //  otherwise prone to distortion. let's move to another
    CarrierBadBand,

    // you're transmitting some Hz above/below what we agreed upon
    CarrierPitchWrong(isize),
}

impl From<WireDataFrame> for WireDataBytes {
    fn from(value: WireDataFrame) -> Self {
        let mut buf: Vec<u8> = Vec::new();
        buf.append(&mut vec![0xAA, 0xAA]); // Alternating high-low prelude
        match value {
            // TODO
            _ => todo!(),
        }
    }
}
